Tutorial
========

The Hypothesis tutorial introduces the main features of Hypothesis. We suggest reading through in order until completing :doc:`/tutorial/custom-strategies`, at which point you can choose to read what seems interesting to you.

If you're in a hurry, the :doc:`quickstart </quickstart>` is a much faster bare-bones version.

.. toctree::
   :maxdepth: 1

   introduction
   builtin-strategies
   adapting-strategies
   custom-strategies
   settings
   replaying-failures
   adding-notes
